//Marfan @ maps.warcraftiii.net 9/9/03

function calc(){
f=document.form;

A = new Object();
B = new Object();

A.WeaponType = 1*f.AWeaponType.value; 
A.ArmorType = 1*f.AArmorType.value; 
B.WeaponType = 1*f.BWeaponType.value; 
B.ArmorType = 1*f.BArmorType.value; 

if (f.war3ver[0].checked){  //RoC
var DamageModifier = new Array(); //Light Medm. Heavy Fort  Hero  None 
DamageModifier[0] = new     Array(  1.50, 1.00, 1.00, 0.50, 1.00, 1.00 ); //Normal
DamageModifier[1] = new     Array(  0.75, 1.00, 1.50, 0.35, 0.50, 1.50 ); //Pierce 
DamageModifier[2] = new     Array(  0.50, 1.00, 1.00, 1.50, 0.50, 1.50 ); //Siege 
DamageModifier[3] = new     Array(  1.00, 2.00, 1.00, 0.50, 0.50, 0.75 ); //Magic 
DamageModifier[4] = new     Array(  1.00, 1.00, 1.00, 1.00, 1.00, 1.00 ); //Chaos 
DamageModifier[5] = new     Array(  1.00, 1.00, 1.00, 0.50, 1.00, 1.00 ); //Hero 
DamageModifier[6] = new     Array(  1.00, 1.00, 1.00, 1.00, 0.75, 1.00 ); //Spells
} else { //TFT
var DamageModifier = new Array(); //Light Medm. Heavy Fort  Hero  None 
DamageModifier[0] = new     Array(  1.00, 1.50, 1.00, 0.70, 1.00, 1.00 ); //Normal
DamageModifier[1] = new     Array(  2.00, 0.75, 1.00, 0.35, 0.50, 1.50 ); //Pierce 
DamageModifier[2] = new     Array(  1.00, 0.50, 1.00, 1.50, 0.50, 1.50 ); //Siege 
DamageModifier[3] = new     Array(  1.25, 0.75, 2.00, 0.35, 0.50, 1.00 ); //Magic 
DamageModifier[4] = new     Array(  1.00, 1.00, 1.00, 1.00, 1.00, 1.00 ); //Chaos 
DamageModifier[5] = new     Array(  1.00, 1.00, 1.00, 0.50, 1.00, 1.00 ); //Hero 
DamageModifier[6] = new     Array(  1.00, 1.00, 1.00, 1.00, 0.75, 1.00 ); //Spells
}
A.DamageFactor   = DamageModifier[A.WeaponType][B.ArmorType];
B.DamageFactor   = DamageModifier[B.WeaponType][A.ArmorType];

//############# UNIT A ################

A.HitPoints     = 1*f.AHitPoints.value;
A.HPRegen       = 1*f.AHPRegen.value;

A.BaseDamage    = 1*f.ABaseDamage.value;
A.NumDice       = 1*f.ANumDice.value;
A.DiceDamage    = 1*f.ADiceDamage.value;
A.WeaponLevel   = 1*f.AWeaponLevel.value;
A.Cooldown      = 1*f.ACooldown.value;
A.WeaponRange   = 1*f.AWeaponRange.value;

A.BaseArmor     = 1*f.ABaseArmor.value;
A.ArmorPerLevel = 1*f.AArmorPerLevel.value;
A.ArmorLevel    = 1*f.AArmorLevel.value;

A.MoveSpeed     = 1*f.AMoveSpeed.value;

A.Strength      = 1*f.AStrength.value-5;
A.Agility       = 1*f.AAgility.value-5;
A.Intelligence  = 1*f.AIntelligence.value-5;
A.PrimaryStat   = f.APrimaryStat[0].checked*0 + f.APrimaryStat[1].checked*1 + f.APrimaryStat[2].checked*2;

A.StatBonusDamage = (A.PrimaryStat==0)*A.Strength + (A.PrimaryStat==1)*A.Agility + (A.PrimaryStat==2)*A.Intelligence;

A.AverageDamage   = (A.BaseDamage+A.StatBonusDamage+(A.NumDice+A.WeaponLevel)*A.DiceDamage/2)* A.DamageFactor; 
A.Cooldown        = (A.Cooldown<0.3)? 0.3 : A.Cooldown;
A.HitsPerMinute   = (A.Agility<195)? 60/A.Cooldown*(1+0.02*A.Agility): 60/A.Cooldown*(1+0.02*200);
A.DamagePerMinute = A.AverageDamage*A.HitsPerMinute;
A.TotalArmor      = A.BaseArmor + A.ArmorPerLevel*A.ArmorLevel + A.Agility*0.3;
A.EffectiveHP     = (A.Strength*25+A.HitPoints)*(1+0.06*A.TotalArmor);

A.TotalRegen      = A.HPRegen + 0.05*A.Strength;


//############# UNIT B ################

B.HitPoints     = 1*f.BHitPoints.value;
B.HPRegen       = 1*f.BHPRegen.value;

B.BaseDamage    = 1*f.BBaseDamage.value;
B.NumDice       = 1*f.BNumDice.value;
B.DiceDamage    = 1*f.BDiceDamage.value;
B.WeaponLevel   = 1*f.BWeaponLevel.value;
B.Cooldown      = 1*f.BCooldown.value;
B.WeaponRange   = 1*f.BWeaponRange.value;

B.BaseArmor     = 1*f.BBaseArmor.value;
B.ArmorPerLevel = 1*f.BArmorPerLevel.value;
B.ArmorLevel    = 1*f.BArmorLevel.value;

B.MoveSpeed     = 1*f.BMoveSpeed.value;

B.Strength      = 1*f.BStrength.value-5;
B.Agility       = 1*f.BAgility.value-5;
B.Intelligence  = 1*f.BIntelligence.value-5;
B.PrimaryStat   = f.BPrimaryStat[0].checked*0 + f.BPrimaryStat[1].checked*1 + f.BPrimaryStat[2].checked*2;

B.StatBonusDamage = (B.PrimaryStat==0)*B.Strength + (B.PrimaryStat==1)*B.Agility + (B.PrimaryStat==2)*B.Intelligence;

B.AverageDamage   = (B.BaseDamage+B.StatBonusDamage+(B.NumDice+B.WeaponLevel)*B.DiceDamage/2)*B.DamageFactor;
B.Cooldown        = (B.Cooldown<0.3)? 0.3 : B.Cooldown;
B.HitsPerMinute   = (B.Agility<195)? 60/B.Cooldown*(1+0.02*B.Agility): 60/B.Cooldown*(1+0.02*200);
B.HitsPerMinute   = (B.HitsPerMinute>600) ? 600 : B.HitsPerMinute;
B.DamagePerMinute = B.AverageDamage*B.HitsPerMinute;
B.TotalArmor      = B.BaseArmor + B.ArmorPerLevel*B.ArmorLevel + B.Agility*0.3;
B.EffectiveHP     = (B.Strength*25+B.HitPoints)*(1+0.06*B.TotalArmor);

B.TotalRegen      = B.HPRegen + 0.05*B.Strength;


//############# Fight ################

A.FreeHitTime=(A.WeaponRange-B.WeaponRange)/B.MoveSpeed;
A.FreeHitTime=(A.FreeHitTime>0)? A.FreeHitTime : 0;
A.FreeHits=Math.floor(A.FreeHitTime/A.HitsPerMinute*60);
B.FreeHitTime=(B.WeaponRange-A.WeaponRange)/A.MoveSpeed;
B.FreeHitTime=(B.FreeHitTime>0)? B.FreeHitTime : 0;
B.FreeHits=Math.floor(B.FreeHitTime/B.HitsPerMinute*60);


A.EffectiveDamage = A.AverageDamage - B.TotalRegen/A.HitsPerMinute;
A.EffectiveDamage = (A.EffectiveDamage<0) ? 0.01 : A.EffectiveDamage;
B.EffectiveDamage = B.AverageDamage - A.TotalRegen/B.HitsPerMinute;
B.EffectiveDamage = (B.EffectiveDamage<0) ? 0.01 : B.EffectiveDamage;

A.HitsToKill = Math.ceil(B.EffectiveHP/(A.EffectiveDamage));
B.HitsToKill = Math.ceil(A.EffectiveHP/(B.EffectiveDamage));
A.TimeToKill = A.HitsToKill/A.HitsPerMinute*60 + B.FreeHitTime;
B.TimeToKill = B.HitsToKill/B.HitsPerMinute*60 + A.FreeHitTime;

if (Math.floor(A.TimeToKill*10-B.TimeToKill*10)==0){ //Tie if within .1 second
TimeToKill= Math.round(A.TimeToKill*10)/10;
if (TimeToKill>1000){
	Outcome="These units cannot hurt eachother.";
}else {
	Outcome="Units tied.  Both died after "+TimeToKill+" seconds of fighting.";
}
} else { //not tie

if (A.TimeToKill<B.TimeToKill){ //A wins
HpLeft=Math.ceil((A.EffectiveHP - B.EffectiveDamage*Math.floor((A.TimeToKill-A.FreeHitTime)*B.HitsPerMinute/60)));
HpLeft= (Math.round(HpLeft/A.EffectiveHP*100)>=100) ? "out taking damage." : " "+Math.round(HpLeft/A.EffectiveHP*100)+"% HP left.";
HitsToKill= Math.ceil(A.HitsToKill);
TimeToKill= Math.round(A.TimeToKill*10)/10;
Outcome="Red won in "+TimeToKill+" seconds ("+HitsToKill+" hits) with"+HpLeft;

} else {  //B wins
HpLeft=Math.ceil((B.EffectiveHP - A.EffectiveDamage*Math.floor((B.TimeToKill-B.FreeHitTime)*A.HitsPerMinute/60)));
HpLeft= (Math.round(HpLeft/B.EffectiveHP*100)>=100) ? "out taking damage." : " "+Math.round(HpLeft/B.EffectiveHP*100)+"% HP left.";
HitsToKill= Math.ceil(B.HitsToKill);
TimeToKill= Math.round(B.TimeToKill*10)/10;
Outcome="Blue won in "+TimeToKill+" seconds ("+HitsToKill+" hits) with"+HpLeft;
}
}



f.AAverageDamage.value=Math.floor(A.AverageDamage*10)/10;
f.ADamagePerMinute.value=Math.floor(A.DamagePerMinute);
f.ATotalArmor.value=Math.floor(A.TotalArmor);
f.AEffectiveHP.value=Math.floor(A.EffectiveHP);
f.AFreeHits.value=Math.floor(A.FreeHits);

f.BAverageDamage.value=Math.floor(B.AverageDamage*10)/10;
f.BDamagePerMinute.value=Math.floor(B.DamagePerMinute);
f.BTotalArmor.value=Math.floor(B.TotalArmor);
f.BEffectiveHP.value=Math.floor(B.EffectiveHP);
f.BFreeHits.value=Math.floor(B.FreeHits);

f.Outcome.value = Outcome;

}